/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the YoutubeVideoConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &YoutubeVideoConnectorFormAllOf{}

// YoutubeVideoConnectorFormAllOf struct for YoutubeVideoConnectorFormAllOf
type YoutubeVideoConnectorFormAllOf struct {
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Data source label
	Label *string `json:"label,omitempty"`
	// Your channel id
	ChannelId *string `json:"channelId,omitempty"`
	// Your playlist id
	PlaylistId *string `json:"playlistId,omitempty"`
	// YT attributes
	Attribute []string `json:"attribute,omitempty"`
}

// NewYoutubeVideoConnectorFormAllOf instantiates a new YoutubeVideoConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewYoutubeVideoConnectorFormAllOf() *YoutubeVideoConnectorFormAllOf {
	this := YoutubeVideoConnectorFormAllOf{}
	return &this
}

// NewYoutubeVideoConnectorFormAllOfWithDefaults instantiates a new YoutubeVideoConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewYoutubeVideoConnectorFormAllOfWithDefaults() *YoutubeVideoConnectorFormAllOf {
	this := YoutubeVideoConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *YoutubeVideoConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *YoutubeVideoConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *YoutubeVideoConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *YoutubeVideoConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *YoutubeVideoConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *YoutubeVideoConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *YoutubeVideoConnectorFormAllOf) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorFormAllOf) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *YoutubeVideoConnectorFormAllOf) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *YoutubeVideoConnectorFormAllOf) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetPlaylistId returns the PlaylistId field value if set, zero value otherwise.
func (o *YoutubeVideoConnectorFormAllOf) GetPlaylistId() string {
	if o == nil || IsNil(o.PlaylistId) {
		var ret string
		return ret
	}
	return *o.PlaylistId
}

// GetPlaylistIdOk returns a tuple with the PlaylistId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorFormAllOf) GetPlaylistIdOk() (*string, bool) {
	if o == nil || IsNil(o.PlaylistId) {
		return nil, false
	}
	return o.PlaylistId, true
}

// HasPlaylistId returns a boolean if a field has been set.
func (o *YoutubeVideoConnectorFormAllOf) HasPlaylistId() bool {
	if o != nil && !IsNil(o.PlaylistId) {
		return true
	}

	return false
}

// SetPlaylistId gets a reference to the given string and assigns it to the PlaylistId field.
func (o *YoutubeVideoConnectorFormAllOf) SetPlaylistId(v string) {
	o.PlaylistId = &v
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *YoutubeVideoConnectorFormAllOf) GetAttribute() []string {
	if o == nil || IsNil(o.Attribute) {
		var ret []string
		return ret
	}
	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorFormAllOf) GetAttributeOk() ([]string, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *YoutubeVideoConnectorFormAllOf) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given []string and assigns it to the Attribute field.
func (o *YoutubeVideoConnectorFormAllOf) SetAttribute(v []string) {
	o.Attribute = v
}

func (o YoutubeVideoConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o YoutubeVideoConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channelId"] = o.ChannelId
	}
	if !IsNil(o.PlaylistId) {
		toSerialize["playlistId"] = o.PlaylistId
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	return toSerialize, nil
}

type NullableYoutubeVideoConnectorFormAllOf struct {
	value *YoutubeVideoConnectorFormAllOf
	isSet bool
}

func (v NullableYoutubeVideoConnectorFormAllOf) Get() *YoutubeVideoConnectorFormAllOf {
	return v.value
}

func (v *NullableYoutubeVideoConnectorFormAllOf) Set(val *YoutubeVideoConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableYoutubeVideoConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableYoutubeVideoConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableYoutubeVideoConnectorFormAllOf(val *YoutubeVideoConnectorFormAllOf) *NullableYoutubeVideoConnectorFormAllOf {
	return &NullableYoutubeVideoConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableYoutubeVideoConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableYoutubeVideoConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
